local starttime = 6 * TICRATE + (3 * TICRATE / 4)
local finishtime = (5*TICRATE+TICRATE/2) + TICRATE/4

-- hud is a fucking mess. no gfx on splitscreen
-- splitscreen fucking sucks ass

local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon and dropped item frame changes depending on the item amount (animation frames become amount frames)

local function DrawTeammateKartItem(teammate, v, itemX, itemY)
	if not patches then
		rawset(_G, "patches", {
			itembg = v.cachePatch("K_ISBG"),
			itembg2 = v.cachePatch("K_ISBGD"),
			itemtimer = v.cachePatch("K_ISIMER"),
			mulsticker = v.cachePatch("K_ISMUL"),
			sneaker = v.cachePatch("K_ISSHOE"),
			rocketsneaker = v.cachePatch("K_ISRSHE"),
			invincibility = {
				v.cachePatch("K_ISINV1"),
				v.cachePatch("K_ISINV2"),
				v.cachePatch("K_ISINV3"),
				v.cachePatch("K_ISINV4"),
				v.cachePatch("K_ISINV5"),
				v.cachePatch("K_ISINV6"),
			},
			banana = v.cachePatch("K_ISBANA"),
			eggman = v.cachePatch("K_ISEGGM"),
			orbinaut = v.cachePatch("K_ISORBN"),
			jawz = v.cachePatch("K_ISJAWZ"),
			mine = v.cachePatch("K_ISMINE"),
			ballhog = v.cachePatch("K_ISBHOG"),
			spb = v.cachePatch("K_ISSPB"),
			grow = v.cachePatch("K_ISGROW"),
			shrink = v.cachePatch("K_ISSHRK"),
			shield = v.cachePatch("K_ISTHNS"),
			ghost = v.cachePatch("K_ISHYUD"),
			pogo = v.cachePatch("K_ISPOGO"),
			sink = v.cachePatch("K_ISSINK"),
			sad = v.cachePatch("K_ISSAD"),
		})
	end
	
	local patch = nil
	local bg = patches.itembg
	local inv = patches.invincibility[(leveltime/3) % 6 + 1]
	-- @TODO splitscreen
	local numberdisplaymin = 2
	local itembar = 0
	
	if teammate.kartstuff[k_itemroulette] then
		patch = ({
			patches.sneaker,
			patches.banana,
			patches.orbinaut,
			patches.mine,
			patches.grow,
			patches.ghost,
			patches.rocketsneaker,
			patches.jawz,
			patches.spb,
			patches.shrink,
			inv,
			patches.eggman,
			patches.ballhog,
			patches.shield,
		})[(teammate.kartstuff[k_itemroulette]/3) % 13 + 1]
	elseif teammate.kartstuff[k_stolentimer] > 0 then
		patch = (leveltime & 2) and patches.ghost or nil
	elseif teammate.kartstuff[k_stealingtimer] > 0 and (leveltime & 2) then
		patch = patches.ghost
	elseif teammate.kartstuff[k_eggmanexplode] > 1 then
		patch = (leveltime & 1) and patches.eggman or nil
	elseif teammate.kartstuff[k_rocketsneakertimer] > 1 then
		itembar = teammate.kartstuff[k_rocketsneakertimer]
		patch = (leveltime & 1) and patches.rocketsneaker or nil
	elseif teammate.kartstuff[k_growshrinktimer] > 1 then
		patch = (leveltime & 1) and patches.grow or nil
	elseif teammate.kartstuff[k_sadtimer] > 0 then
		patch = (leveltime & 2) and patches.sad or nil
	elseif teammate.kartstuff[k_itemamount] == 0 then
		return
	elseif (not teammate.kartstuff[k_itemheld]) or (leveltime & 1) then
		patch = ({
			[KITEM_SNEAKER] = patches.sneaker,
			[KITEM_ROCKETSNEAKER] = patches.rocketsneaker,
			[KITEM_INVINCIBILITY] = inv,
			[KITEM_BANANA] = patches.banana,
			[KITEM_EGGMAN] = patches.eggman,
			[KITEM_ORBINAUT] = patches.orbinaut,
			[KITEM_JAWZ] = patches.jawz,
			[KITEM_MINE] = patches.mine,
			[KITEM_BALLHOG] = patches.ballhog,
			[KITEM_SPB] = patches.spb,
			[KITEM_GROW] = patches.grow,
			[KITEM_SHRINK] = patches.shrink,
			[KITEM_THUNDERSHIELD] = patches.shield,
			[KITEM_HYUDORO] = patches.ghost,
			[KITEM_POGOSPRING] = patches.pogo,
			[KITEM_KITCHENSINK] = patches.sink,
			[KITEM_SAD] = patches.sad,
		})[teammate.kartstuff[k_itemtype]]
		if patch == inv then
			bg = patches.itembg2
		end
	end
	
	local flags = V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT
	
	v.draw(itemX, itemY, bg, flags)
	
	local colormap = nil
	if teammate.kartstuff[k_itemroulette] then
		colormap = v.getColormap(TC_RAINBOW, teammate.skincolor)
	elseif teammate.kartstuff[k_itemblink] and (leveltime & 1) then
		colormap = v.getColormap(TC_BLINK, ({
			[0] = SKINCOLOR_WHITE,
			SKINCOLOR_RED,
			1 + (leveltime % (MAXSKINCOLORS-1))
		})[teammate.kartstuff[k_itemblinkmode]])
	end
	
	if teammate.kartstuff[k_itemamount] >= numberdisplaymin and not teammate.kartstuff[k_itemroulette] then
		v.draw(itemX, itemY, patches.mulsticker, flags)
		if patch then
			v.draw(itemX, itemY, patch, flags, colormap)
		end
		v.drawString(itemX+24, itemY+31, "x" .. teammate.kartstuff[k_itemamount], V_ALLOWLOWERCASE|flags)
	elseif patch then
		v.draw(itemX, itemY, patch, flags, colormap)
	end
	
	if itembar then
		local itemtime = 8*TICRATE
		local barlength = 12
		local maxl = (itemtime*3) - barlength
		local fill = (itembar*barlength)/maxl
		local length = min(barlength, fill)
		local height = 1
		
		v.draw(itemX+17, itemY+27, patches.itemtimer, flags)
		v.drawFill(itemX+18, itemY+18, (length == 2 and 2 or 1), height, 12|flags)
		
		if length > 2 then
			v.drawFill(itemX+17+length, itemY+28, 1, height, 12|flags)
			v.drawFill(itemX+19, itemY+28, length-2, 1, 120|flags)
		end
	end
	
	-- draw the teammate's face too!
	if teammate.mo and teammate.mo.valid then
		v.draw(itemX+(itemX > 160 and 8 or 30), itemY+12, v.cachePatch(skins[teammate.mo.skin].facemmap), flags, v.getColormap(teammate.mo.skin, teammate.mo.color))
	end
end

local spinoutstart = {}

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not spinoutstart[#p] and p.kartstuff[k_spinouttimer] then
			spinoutstart[#p] = leveltime
		elseif spinoutstart[#p] and not p.kartstuff[k_spinouttimer] then
			spinoutstart[#p] = nil
		end
	end
end)

local function calcXOffsetSpinout(p, dt)
	if not (p and p.valid) then return 0 end -- this is stupid i hate this pls
	if dt == 1 and not (p.combi_p and p.combi_p.valid) then return 0 end -- this is stupid i hate this pls
	
	--dont do any shake
	if not (spinoutstart[#p] or (dt == 1 and spinoutstart[#p.combi_p])) then return 0 end

	local spint = p.kartstuff[k_spinouttimer]
	if p.pflags&PF_TIMEOVER then
		spint = 0
	end
	local spintc = 0
	if dt == 1 then
		if p.combi_p.pflags&PF_TIMEOVER then
			spintc = 0
		else
			spintc = p.combi_p.kartstuff[k_spinouttimer]
		end
	end

	--figgure out some player specific vars for combi
	local t = leveltime-(spinoutstart[#p] or leveltime)
	local spinoutt = spint
	if dt == 1 then
		t = leveltime - max(spinoutstart[#p] or spinoutstart[#p.combi_p], spinoutstart[#p.combi_p] or spinoutstart[#p])
		spinoutt = max(spint or spintc, spintc or spint)
	end
	local spinoutang = FixedAngle(FixedDiv((t%(TICRATE/2)), TICRATE)*720)
	--print(spinoutang/ANG1)
	local spinoutshake = (sin(spinoutang)*spinoutt)/5
	--print(spinoutshake)
	return spinoutshake
end

-- xitem sutff
local function DrawTeammateItem(teammate, v, itemX, itemY)
	local itemBG = v.cachePatch("K_ISBG")
	local itemDat = nil
	if not xItemLib then 
		-- redirect to original fickle code if xitem is not present
		DrawTeammateKartItem(teammate, v, itemX, itemY)
		return
	end
	-- i am WAY too lazy to implement support for itemodds fuck you
	local i = (leveltime/3 % xItemLib.func.countItems() + 1)
	-- teammate is NOT in roulette
	if not teammate.xItemData.xItem_roulette then
		i = teammate.kartstuff[k_itemtype]
	end
	itemDat = xItemLib.func.getItemDataById(i)
	local s, icn, get
	if i > 0 then
		local idx = 0
		if itemDat.flags and (itemDat.flags & XIF_ICONFORAMT) then 
			idx = teammate.kartstuff[k_itemamount]
		else
			idx = leveltime
		end
		s, get = itemDat.getItemPatchSingle(true, idx)
		icn = v.cachePatch(s)
	end
	
	-- no item pendejo
	if i <= 0 then return end
	
	local flags = V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT
	
	local colormap = nil
	if teammate.kartstuff[k_itemroulette] then
		colormap = v.getColormap(TC_RAINBOW, teammate.skincolor)
	elseif teammate.kartstuff[k_itemblink] and (leveltime & 1) then
		colormap = v.getColormap(TC_BLINK, ({
			[0] = SKINCOLOR_WHITE,
			SKINCOLOR_RED,
			1 + (leveltime % (MAXSKINCOLORS-1))
		})[teammate.kartstuff[k_itemblinkmode]])
	end
	
	v.draw(itemX, itemY, itemBG, flags)
	
	local drawAmt = (not (itemDat.flags and (itemDat.flags & XIF_ICONFORAMT))) or (itemDat.flags and (itemDat.flags & XIF_ICONFORAMT) and teammate.kartstuff[k_itemamount] > get)
	if teammate.kartstuff[k_itemamount] > 1 and drawAmt then
		v.draw(itemX, itemY, v.cachePatch("K_ISMUL"), flags)
		if icn then
			v.draw(itemX, itemY, icn, flags, colormap)
		end
		v.drawString(itemX+24, itemY+31, "x" .. teammate.kartstuff[k_itemamount], V_ALLOWLOWERCASE|flags)
	elseif icn then
		v.draw(itemX, itemY, icn, flags, colormap)
	end
end

-- taken from original combi ring mod with some tweaks



local plst = {1}
local adt = 0

hcombi.PartnerHud = function(v, player, c)
	if not hcombi.combi_on then return end
	--if splitscreen then return end
	local p = displayplayers[0]
	if not p then return end
	if not p.mo then return end
	local heart = v.cachePatch("HEART1")
	local you = v.cachePatch(skins[p.mo.skin].facerank)
	local partner = v.cachePatch("UKRNK1")
	local colmap = v.getColormap(p.mo.skin, p.mo.color)
	if p.mo.colorized then
		colmap = v.getColormap(TC_RAINBOW, p.mo.color)
	end
	local colmap_p = nil
	if p.combi ~= nil then
		colmap_p = v.getColormap(p.combi_p.mo.skin, p.combi_p.mo.color)
		if p.combi_p.mo.colorized then
			colmap_p = v.getColormap(TC_RAINBOW, p.combi_p.mo.color)
		end
	end
	if p.has_partner and leveltime >= finishtime then
		heart = v.cachePatch("HEART2")
		partner = v.cachePatch(skins[p.combi_p.mo.skin].facerank)
	elseif not p.has_partner and leveltime >= finishtime then
		heart = v.cachePatch("HEART1")
	elseif leveltime >= 2 then
		local pn = "UKRNK1"
		heart = v.cachePatch("HEART2")
		partner = v.cachePatch(pn)
	end
	
	local fade = v.localTransFlag(v)>>V_ALPHASHIFT
	
	local startfade = v.localTransFlag(v)>>V_ALPHASHIFT
	local fade = leveltime >= starttime and (min(9, startfade + (leveltime- starttime))) or startfade
	
	if leveltime > 2 then
		-- SHUT UP!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		if not p.fake_combi or not p.old_combi then return end
		local combiname = "---"
		if p.fake_combi and p.fake_combi.valid then 
			combiname = p.fake_combi.name
		end
		local nextcombiname = "---"
		if p.old_combi and p.old_combi.valid then 
			nextcombiname = p.old_combi.name
		end
		
		if p.fake_combi.valid and p.fake_combi.name == "anti-loneliness gargoyle" then
			combiname = "---"
		end
		if p.old_combi.valid and p.old_combi.name == "anti-loneliness gargoyle" then
			nextcombiname = "---"
		end
		
		if leveltime > finishtime then
			combiname = p.combi_p.name
		end
		
		local scroll = FixedMul(FixedDiv(hcombi.combi_initscroll, 6*TICRATE), 10)
		local pos = min(max(leveltime - 100, 120), 140)
		local flags = V_SNAPTOBOTTOM | (leveltime > finishtime+TICRATE and V_HUDTRANS or 0)
					
		if leveltime <= finishtime then
			v.drawFill(0, pos - 3, 320, 14, 24|V_SNAPTOBOTTOM)
		end
		
		if p.old_combi and scroll > 0 then
			v.drawString(170, pos + 10 - scroll + adt, nextcombiname, V_ALLOWLOWERCASE|flags, leveltime >= finishtime and "thin" or "left")
		end
		
		adt = leveltime > finishtime and min(adt+1, 7) or 0
					
		v.drawString(150, pos+adt, p.name, V_ALLOWLOWERCASE|flags, leveltime >= finishtime and "thin-right" or "right")
		v.drawString(170, pos - scroll + adt, combiname, V_ALLOWLOWERCASE|flags, leveltime >= finishtime and "thin" or "left")
					
		if leveltime <= finishtime then
			local color = min(leveltime & 31, 31 - (leveltime & 31)) + 160
			v.drawFill(0, pos - 9, 320, 6, color|V_SNAPTOBOTTOM)
			v.drawFill(0, pos + 11, 320, 6, color|V_SNAPTOBOTTOM)
		end
		
		if leveltime <= finishtime then
			for i = -16,16 do
				v.drawString((80 - (leveltime - finishtime))+(80*i),pos-21, "Please wait...", V_SNAPTOBOTTOM|V_50TRANS|V_ALLOWLOWERCASE, "thin")
				v.drawString((80 + (leveltime - finishtime))-(80*i),pos+19, "Please wait...", V_SNAPTOBOTTOM|V_50TRANS|V_ALLOWLOWERCASE, "thin")
			end
		end
		
		v.draw(160 - (21/2), pos + (25/2), heart, V_SNAPTOBOTTOM | V_TRANSLUCENT)
		
		v.draw((160 - 25) + FixedInt(calcXOffsetSpinout(p, 0)), pos + (25/2) + 4, you, flags, colmap)
		local addi = 0
		if p.has_partner then
			addi = FixedInt(calcXOffsetSpinout(p.combi_p, 0))
		end
		v.draw((160 + (21/2)) + addi, pos + (25/2) + 4, partner, flags, colmap_p)
	end
	
	if p.has_partner then DrawTeammateItem(p.combi_p, v, 42, -3) end
end

hud.add(hcombi.PartnerHud)