-- i still dont know why this isnt just a lua global
local starttime = 6 * TICRATE + (3 * TICRATE / 4)

hcombi.TurnHud = function(v, player, c)
	-- do not execute ANYTHING here when combi is not on.
	if not hcombi.combi_on then return end
	-- spectator? no problem.
	if player.spectator then return end
	if leveltime < starttime then return end
	-- no combi partner? no problem.
	if not player.fake_combi or not player.old_combi then return end
	
	local prtnr = player.combi_p
	if not prtnr or not prtnr.valid then return end

	-- get our combi partner's mobj
	local prtnr_mo = prtnr.mo
	
	-- no player? no problem.
	if not prtnr_mo or not prtnr_mo.valid then return end
	
	-- get the player obj after checking if valid
	local prtnr = prtnr_mo.player
	
	if player.receivedcooldown then 
		local trans = abs(player.receivedcooldown / 5) % 3 + 6
		trans = $ << FF_TRANSSHIFT
		local scale = FRACUNIT
		local basex = v.width() / v.dupx() / 2 * FRACUNIT
		local basey = v.height() / v.dupy() * FRACUNIT
		if player.receivedturnsignal == 1 then -- turn left
			v.draw(160-(66*2), 100-33, v.cachePatch("T_LEFTB"), trans)
		end
		if player.receivedturnsignal == 2 then -- turn right
			v.draw(160+66, 100-33, v.cachePatch("T_RGHTB"), trans)
		end
		if player.receivedturnsignal == 3 then -- straight
			v.draw(160-33, 20, v.cachePatch("T_SRGTB"), trans)
		end
		if player.receivedturnsignal == 4 then -- wrong
			v.draw(160-33, 20, v.cachePatch("T_WRNGB"), trans)
		end
	end
	
	local pos = min(max(leveltime - 100, 120), 140)
	local flags = 0
		
	if player.turnsignalcooldown then
		if player.turnsignalsent == 1 then
			v.draw(160-17, 20, v.cachePatch("T_LEFTS"), V_SNAPTOTOP|FF_TRANS50)
		end
		if player.turnsignalsent == 2 then -- turn right
			v.draw(160-17, 20, v.cachePatch("T_RGHTS"), V_SNAPTOTOP|FF_TRANS50)
		end
		if player.turnsignalsent == 3 then -- straight
			v.draw(160-17, 20, v.cachePatch("T_SRGTS"), V_SNAPTOTOP|FF_TRANS50)
		end
		if player.turnsignalsent == 4 then -- wrong
			v.draw(160-17, 20, v.cachePatch("T_WRNGS"), V_SNAPTOTOP|FF_TRANS50)
		end
	end
end

hud.add(hcombi.TurnHud)